<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApplicationFault StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ApplicationFault
 * @subpackage Structs
 */
class ApplicationFault extends AbstractStructBase
{
    /**
     * The ErrorMessage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorMessage;
    /**
     * The MessageExceptionDictionary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SerializableDictionaryOfguidstring
     */
    public $MessageExceptionDictionary;
    /**
     * Constructor method for ApplicationFault
     * @uses ApplicationFault::setErrorMessage()
     * @uses ApplicationFault::setMessageExceptionDictionary()
     * @param string $errorMessage
     * @param \StructType\SerializableDictionaryOfguidstring $messageExceptionDictionary
     */
    public function __construct($errorMessage = null, \StructType\SerializableDictionaryOfguidstring $messageExceptionDictionary = null)
    {
        $this
            ->setErrorMessage($errorMessage)
            ->setMessageExceptionDictionary($messageExceptionDictionary);
    }
    /**
     * Get ErrorMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorMessage()
    {
        return isset($this->ErrorMessage) ? $this->ErrorMessage : null;
    }
    /**
     * Set ErrorMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorMessage
     * @return \StructType\ApplicationFault
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorMessage)), __LINE__);
        }
        if (is_null($errorMessage) || (is_array($errorMessage) && empty($errorMessage))) {
            unset($this->ErrorMessage);
        } else {
            $this->ErrorMessage = $errorMessage;
        }
        return $this;
    }
    /**
     * Get MessageExceptionDictionary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SerializableDictionaryOfguidstring|null
     */
    public function getMessageExceptionDictionary()
    {
        return isset($this->MessageExceptionDictionary) ? $this->MessageExceptionDictionary : null;
    }
    /**
     * Set MessageExceptionDictionary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SerializableDictionaryOfguidstring $messageExceptionDictionary
     * @return \StructType\ApplicationFault
     */
    public function setMessageExceptionDictionary(\StructType\SerializableDictionaryOfguidstring $messageExceptionDictionary = null)
    {
        if (is_null($messageExceptionDictionary) || (is_array($messageExceptionDictionary) && empty($messageExceptionDictionary))) {
            unset($this->MessageExceptionDictionary);
        } else {
            $this->MessageExceptionDictionary = $messageExceptionDictionary;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ApplicationFault
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
